Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Sitar Class Reference

STK sitar string model class. More...

`#include <Sitar.h>`

Inheritance diagram for stk::Sitar:

List of all members.

## Public Member Functions
| Sitar (StkFloat lowestFrequency=8.0)
| Class constructor, taking the lowest desired playing frequency.
| ~Sitar (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | pluck (StkFloat amplitude)
| Pluck the string with the given amplitude using the current frequency.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK sitar string model class.

This class implements a sitar plucked string physical model based on the Karplus-Strong algorithm.

This is a digital waveguide model, making its use possibly subject to patents held by Stanford University, Yamaha, and others. There exist at least two patents, assigned to Stanford, bearing the names of Karplus and/or Strong.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Member Function Documentation

StkFrames & stk::Sitar::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

    00100 {
    00101   unsigned int nChannels = lastFrame_.channels();
    00102 #if defined(_STK_DEBUG_)
    00103   if ( channel > frames.channels() - nChannels ) {
    00104     oStream_ << "Sitar::tick(): channel and StkFrames arguments are incompatible!";
    00105     handleError( StkError::FUNCTION_ARGUMENT );
    00106   }
    00107 #endif
    00108
    00109   StkFloat *samples = &frames[channel];
    00110   unsigned int j, hop = frames.channels() - nChannels;
    00111   if ( nChannels == 1 ) {
    00112     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00113       *samples++ = tick();
    00114   }
    00115   else {
    00116     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00117       *samples++ = tick();
    00118       for ( j=1; j<nChannels; j++ )
    00119         *samples++ = lastFrame_[j];
    00120     }
    00121   }
    00122
    00123   return frames;
    00124 }

The documentation for this class was generated from the following file:

- Sitar.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.